<?php

$className = "rbs";
$paymentName = "RBSPayment";

include "standalone.php";

try {
    $objectTypesCollection = umiObjectTypesCollection::getInstance();
    $objectsCollection = umiObjectsCollection::getInstance();
    $fieldTypesCollection = umiFieldTypesCollection::getInstance();
    $fieldsCollection = umiFieldsCollection::getInstance();

    // типы данных
    $intField = $fieldTypesCollection->getFieldTypeByDataType("int");
    $stringField = $fieldTypesCollection->getFieldTypeByDataType("string");
    $booleanField = $fieldTypesCollection->getFieldTypeByDataType("boolean");
    $relationField = $fieldTypesCollection->getFieldTypeByDataType("relation");

    // получаем родительский тип
    $paymentTypeId = $objectTypesCollection->getTypeIdByGUID("emarket-payment");
    $paymentTypeGuidId = $objectTypesCollection->getTypeIdByGUID("emarket-paymenttype");


    // добавление нового справочника
    $typeObjectId = $objectTypesCollection->addType($paymentTypeId, $paymentName);
    $guide = $objectTypesCollection->getType($typeObjectId);
    $guide->setGUID("emarket-payment-{$typeObjectId}");
    $guide->setIsGuidable(false);
    $guide->setIsPublic(false);

    $propsGroupMainId = $guide->addFieldsGroup('rbs_settings', 'Основные настройки');
    $propsGroupMain = new umiFieldsGroup($propsGroupMainId);

    $userNameFieldId = $fieldsCollection->addField('login', 'Логин', $stringField->getId());
    $userNameField = $fieldsCollection->getField($userNameFieldId);
//    $userNameField->setTip("Логин магазина, полученный при подключении");
    $propsGroupMain->attachField($userNameFieldId);

    $passwordFieldId = $fieldsCollection->addField('password', 'Пароль', $stringField->getId());

    $passwordField = $fieldsCollection->getField($passwordFieldId);
//    $passwordField->setTip("Пароль магазина, полученный при подключении");
//    $passwordField->setImportanceStatus(true);
    $propsGroupMain->attachField($passwordFieldId);

    $testFieldId = $fieldsCollection->addField('test_mode', 'Тестовый режим работы', $booleanField->getId());
//    $testFieldId->setIsRequired(true);
    $propsGroupMain->attachField($testFieldId);

    $twoStageFieldId = $fieldsCollection->addField('two-stage', 'Двух-стадийные платежи', $booleanField->getId());
//    $twoStageFieldId->setIsRequired(true);
    $propsGroupMain->attachField($twoStageFieldId);

    $propsGroupMain->setIsActive(true);
    $propsGroupMain->setIsVisible(true);
    $propsGroupMain->commit();


    $propsGroupExtId = $guide->addFieldsGroup('rbs_settings_ext', 'Дополнительные настройки');
    $propsGroupExt = new umiFieldsGroup($propsGroupExtId);

    $sendOrderFieldId = $fieldsCollection->addField('send_order', 'Передавать данные для печати чека', $booleanField->getId());
//    $sendOrderFieldId->setIsRequired(true);
    $propsGroupExt->attachField($sendOrderFieldId);

    $taxSystemFieldId = $fieldsCollection->addField('taxSystem', 'Система налогообложения', $stringField->getId());
//    $taxSystemFieldId->setImportanceStatus(true);
    $propsGroupExt->attachField($taxSystemFieldId);

    $ffd_versionFieldId = $fieldsCollection->addField('ffd_version', 'Формат фискальных документов', $stringField->getId());
//    $ffd_versionFieldId->setImportanceStatus(true);
    $propsGroupExt->attachField($ffd_versionFieldId);

    $ffd_paymentMethodTypeFieldId = $fieldsCollection->addField('ffd_paymentMethodType', 'Тип оплаты', $stringField->getId());
//    $ffd_paymentMethodTypeFieldId->setImportanceStatus(true);
    $propsGroupExt->attachField($ffd_paymentMethodTypeFieldId);

    $ffd_paymentObjectTypeFieldId = $fieldsCollection->addField('ffd_paymentObjectType', 'Тип оплачиваемой позиции', $stringField->getId());
//    $ffd_paymentObjectTypeFieldId->setImportanceStatus(true);
    $propsGroupExt->attachField($ffd_paymentObjectTypeFieldId);


    $writeLogFieldId = $fieldsCollection->addField('logging', 'Включить логирование', $booleanField->getId());
//    $writeLogFieldId->setIsRequired(true);
    $propsGroupExt->attachField($writeLogFieldId);


    $propsGroupExt->commit();

    $objectTypesCollection->clearCache();

    // Добавляем данные в справочник
    $internalObjectId = $objectsCollection->addObject($paymentName, $paymentTypeGuidId);
    $internalObject = $objectsCollection->getObject($internalObjectId);
    $internalObject->setValue('class_name', $className);

    // связываем его с типом
    $internalObject->setValue('payment_type_id', $typeObjectId);
    $internalObject->setValue('payment_type_guid', "emarket-payment-{$typeObjectId}");
    $internalObject->commit();



    echo $paymentName . " успешно установлен!";
} catch (Exception $e) {
    echo $e->getMessage();
}

//// Тип для внутреннего объекта, связанного с публичным типом
//$internalTypeId = $objectTypesCollection->getTypeIdByGUID("emarket-paymenttype");
//$typeId = $objectTypesCollection->addType($parentTypeId, $paymentName);
//
//// Создаем внутренний объект
//$internalObjectId = $objectsCollection->addObject($paymentName, $internalTypeId);
//$internalObject = $objectsCollection->getObject($internalObjectId);
//$internalObject->setValue("class_name", $className); // имя класса для реализации
//
//// связываем его с типом
//$internalObject->setValue("payment_type_id", $typeId);
//$internalObject->setValue("payment_type_guid", "user-emarket-payment-" . $typeId);
//$internalObject->commit();
//
//// Связываем внешний тип и внутренний объект
//$type = $objectTypesCollection->getType($typeId);
//$type->setGUID($internalObject->getValue("payment_type_guid"));
//$type->commit();

